VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMyFunctions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IFunction

Private Sub iFunction_Callback(ByVal ZeroBasedNameIndex As Long, ByVal ParamCount As Long, UDF As cUDFMethods)
  Select Case ZeroBasedNameIndex
    Case 0 'AddSomething (the first entry in the comma-separated list in iFunction_DefinedNames)
      If ParamCount = 2 Then 'the "normal case"
        UDF.SetResultDouble UDF.GetDouble(1) + UDF.GetDouble(2) 'parameter-indices are one-based
      Else 'an example, how to raise an error, if something cannot be handled by your function
        UDF.SetResultError "AddSomething: we need two parameters!"
      End If
      
    Case 1 'StrReverse (the second entry in the comma-separated list in iFunction_DefinedNames)
      If UDF.GetType(1) = SQLite_NULL Then 'another error-handling-example
        'here we don't raise an error...
        'instead we "delegate" the current param-content to the sqlite-function-result
        UDF.SetResultToParam 1
      Else 'process the parameter and deliver the result
        'the Get-Functions of the UDF-Object have builtin Type-Conversion,
        'so in this case .GetText(1) autoconverts the content of the
        'field- or expression (given in parameter 1) always into a VB-UnicodeString,
        'regardless it the Field contains an Integer, a Double, a Date or a BLOB
        UDF.SetResultText StrReverse$(UDF.GetText(1))
      End If
  End Select
End Sub

'here we define two function-names as a comma-separated "list"
Private Property Get iFunction_DefinedNames() As String
  iFunction_DefinedNames = "AddSomething,StrReverse"
End Property
