VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDXBlt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public InitErr&

Private objDX As New DirectX7, objDD As DirectDraw7
Private PSrf As DirectDrawSurface7, Srf1 As DirectDrawSurface7
Private ddsd1 As DDSURFACEDESC2, ddsd2 As DDSURFACEDESC2
Private dx&, dy&

Private Sub Class_Initialize()
  On Error Resume Next
    Set objDD = objDX.DirectDrawCreate("")
    objDD.SetCooperativeLevel 0, DDSCL_NORMAL
    
    ddsd1.lFlags = DDSD_CAPS
    ddsd1.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
    Set PSrf = objDD.CreateSurface(ddsd1)
    
    objDD.GetDisplayMode ddsd2
    ddsd2.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT
    ddsd2.ddsCaps.lCaps = DDSCAPS_TEXTURE
    
    dx = (Screen.Width / Screen.TwipsPerPixelX) \ 2
    dy = (Screen.Height / Screen.TwipsPerPixelY) \ 2
    ddsd2.lWidth = dx: ddsd2.lHeight = dy
    Set Srf1 = objDD.CreateSurface(ddsd2)
  
    InitErr = Err.Number
  Err.Clear
End Sub

Private Sub Class_Terminate()
 On Error Resume Next
  Set PSrf = Nothing
  Set Srf1 = Nothing
  Set objDX = Nothing
  Set objDD = Nothing
 Err.Clear
End Sub

Public Sub DxBlt(Optional ByVal hDC&)
Dim R1 As DxVBLib.RECT, R2 As DxVBLib.RECT, BltFx As DDBLTFX

 On Error Resume Next
  R2.Right = dx: R2.Bottom = dy

  Dim PRct As RECT, SRct As RECT 'empty Rects mean: Full-Surface-Area is blitted
  Srf1.Blt SRct, PSrf, PRct, DDBLT_ASYNC Or DDBLT_DONOTWAIT  'copy the Screen to Srf1 (wich has half the size)
  Srf1.BltToDC hDC, SRct, R2    'and now after the quality-stretch into our Memory-Area (over the DIBDC)
 Err.Clear
End Sub

'DirectX-Error-Translation
Private Function GetErrString$(ByVal ErrNr&)
  Select Case ErrNr
    Case DD_OK: GetErrString = "DD_OK"
    Case DDENUMRET_CANCEL: GetErrString = "DDENUMRET_CANCEL"
    Case DDENUMRET_OK: GetErrString = "DDENUMRET_OK"
    Case DDERR_ALREADYINITIALIZED: GetErrString = "DDERR_ALREADYINITIALIZED"
    Case DDERR_BLTFASTCANTCLIP: GetErrString = "DDERR_BLTFASTCANTCLIP"
    Case DDERR_CANNOTATTACHSURFACE: GetErrString = "DDERR_CANNOTATTACHSURFACE"
    Case DDERR_CANNOTDETACHSURFACE: GetErrString = "DDERR_CANNOTDETACHSURFACE"
    Case DDERR_CANTCREATEDC: GetErrString = "DDERR_CANTCREATEDC"
    Case DDERR_CANTDUPLICATE: GetErrString = "DDERR_CANTDUPLICATE"
    Case DDERR_CANTLOCKSURFACE: GetErrString = "DDERR_CANTLOCKSURFACE"
    Case DDERR_CANTPAGELOCK: GetErrString = "DDERR_CANTPAGELOCK"
    Case DDERR_CANTPAGEUNLOCK: GetErrString = "DDERR_CANTPAGEUNLOCK"
    Case DDERR_CLIPPERISUSINGHWND: GetErrString = "DDERR_CLIPPERISUSINGHWND"
    Case DDERR_COLORKEYNOTSET: GetErrString = "DDERR_COLORKEYNOTSET"
    Case DDERR_CURRENTLYNOTAVAIL: GetErrString = "DDERR_CURRENTLYNOTAVAIL"
    Case DDERR_DCALREADYCREATED: GetErrString = "DDERR_DCALREADYCREATED"
    Case DDERR_DEVICEDOESNTOWNSURFACE: GetErrString = "DDERR_DEVICEDOESNTOWNSURFACE"
    Case DDERR_DIRECTDRAWALREADYCREATED: GetErrString = "DDERR_DIRECTDRAWALREADYCREATED"
    Case DDERR_EXCEPTION: GetErrString = "DDERR_EXCEPTION"
    Case DDERR_EXCLUSIVEMODEALREADYSET: GetErrString = "DDERR_EXCLUSIVEMODEALREADYSET"
    Case DDERR_EXPIRED: GetErrString = "DDERR_EXPIRED"
    Case DDERR_GENERIC: GetErrString = "DDERR_GENERIC"
    Case DDERR_HEIGHTALIGN: GetErrString = "DDERR_HEIGHTALIGN"
    Case DDERR_HWNDALREADYSET: GetErrString = "DDERR_HWNDALREADYSET"
    Case DDERR_HWNDSUBCLASSED: GetErrString = "DDERR_HWNDSUBCLASSED"
    Case DDERR_IMPLICITLYCREATED: GetErrString = "DDERR_IMPLICITLYCREATED"
    Case DDERR_INCOMPATIBLEPRIMARY: GetErrString = "DDERR_INCOMPATIBLEPRIMARY"
    Case DDERR_INVALIDCAPS: GetErrString = "DDERR_INVALIDCAPS"
    Case DDERR_INVALIDCLIPLIST: GetErrString = "DDERR_INVALIDCLIPLIST"
    Case DDERR_INVALIDDIRECTDRAWGUID: GetErrString = "DDERR_INVALIDDIRECTDRAWGUID"
    Case DDERR_INVALIDMODE: GetErrString = "DDERR_INVALIDMODE"
    Case DDERR_INVALIDOBJECT: GetErrString = "DDERR_INVALIDOBJECT"
    Case DDERR_INVALIDPARAMS: GetErrString = "DDERR_INVALIDPARAMS"
    Case DDERR_INVALIDPIXELFORMAT: GetErrString = "DDERR_INVALIDPIXELFORMAT"
    Case DDERR_INVALIDPOSITION: GetErrString = "DDERR_INVALIDPOSITION"
    Case DDERR_INVALIDRECT: GetErrString = "DDERR_INVALIDRECT"
    Case DDERR_INVALIDSTREAM: GetErrString = "DDERR_INVALIDSTREAM"
    Case DDERR_INVALIDSURFACETYPE: GetErrString = "DDERR_INVALIDSURFACETYPE"
    Case DDERR_LOCKEDSURFACES: GetErrString = "DDERR_LOCKEDSURFACES"
    Case DDERR_MOREDATA: GetErrString = "DDERR_MOREDATA"
    Case DDERR_NO3D: GetErrString = "DDERR_NO3D"
    Case DDERR_NOALPHAHW: GetErrString = "DDERR_NOALPHAHW"
    Case DDERR_NOBLTHW: GetErrString = "DDERR_NOBLTHW"
    Case DDERR_NOCLIPLIST: GetErrString = "DDERR_NOCLIPLIST"
    Case DDERR_NOCLIPPERATTACHED: GetErrString = "DDERR_NOCLIPPERATTACHED"
    Case DDERR_NOCOLORCONVHW: GetErrString = "DDERR_NOCOLORCONVHW"
    Case DDERR_NOCOLORKEY: GetErrString = "DDERR_NOCOLORKEY"
    Case DDERR_NOCOLORKEYHW: GetErrString = "DDERR_NOCOLORKEYHW"
    Case DDERR_NOCOOPERATIVELEVELSET: GetErrString = "DDERR_NOCOOPERATIVELEVELSET"
    Case DDERR_NODC: GetErrString = "DDERR_NODC"
    Case DDERR_NODDROPSHW: GetErrString = "DDERR_NODDROPSHW"
    Case DDERR_NODIRECTDRAWHW: GetErrString = "DDERR_NODIRECTDRAWHW"
    Case DDERR_NODIRECTDRAWSUPPORT: GetErrString = "DDERR_NODIRECTDRAWSUPPORT"
    Case DDERR_NOEMULATION: GetErrString = "DDERR_NOEMULATION"
    Case DDERR_NOEXCLUSIVEMODE: GetErrString = "DDERR_NOEXCLUSIVEMODE"
    Case DDERR_NOFLIPHW: GetErrString = "DDERR_NOFLIPHW"
    Case DDERR_NOFOCUSWINDOW: GetErrString = "DDERR_NOFOCUSWINDOW"
    Case DDERR_NOGDI: GetErrString = "DDERR_NOGDI"
    Case DDERR_NOHWND: GetErrString = "DDERR_NOHWND"
    Case DDERR_NOMIPMAPHW: GetErrString = "DDERR_NOMIPMAPHW"
    Case DDERR_NOMIRRORHW: GetErrString = "DDERR_NOMIRRORHW"
    Case DDERR_NONONLOCALVIDMEM: GetErrString = "DDERR_NONONLOCALVIDMEM"
    Case DDERR_NOOPTIMIZEHW: GetErrString = "DDERR_NOOPTIMIZEHW"
    Case DDERR_NOOVERLAYDEST: GetErrString = "DDERR_NOOVERLAYDEST"
    Case DDERR_NOOVERLAYHW: GetErrString = "DDERR_NOOVERLAYHW"
    Case DDERR_NOPALETTEATTACHED: GetErrString = "DDERR_NOPALETTEATTACHED"
    Case DDERR_NOPALETTEHW: GetErrString = "DDERR_NOPALETTEHW"
    Case DDERR_NORASTEROPHW: GetErrString = "DDERR_NORASTEROPHW"
    Case DDERR_NOROTATIONHW: GetErrString = "DDERR_NOROTATIONHW"
    Case DDERR_NOSTEREOHARDWARE: GetErrString = "DDERR_NOSTEREOHARDWARE"
    Case DDERR_NOSTRETCHHW: GetErrString = "DDERR_NOSTRETCHHW"
    Case DDERR_NOSURFACELEFT: GetErrString = "DDERR_NOSURFACELEFT"
    Case DDERR_NOT4BITCOLOR: GetErrString = "DDERR_NOT4BITCOLOR"
    Case DDERR_NOT4BITCOLORINDEX: GetErrString = "DDERR_NOT4BITCOLORINDEX"
    Case DDERR_NOT8BITCOLOR: GetErrString = "DDERR_NOT8BITCOLOR"
    Case DDERR_NOTAOVERLAYSURFACE: GetErrString = "DDERR_NOTAOVERLAYSURFACE"
    Case DDERR_NOTEXTUREHW: GetErrString = "DDERR_NOTEXTUREHW"
    Case DDERR_NOTFLIPPABLE: GetErrString = "DDERR_NOTFLIPPABLE"
    Case DDERR_NOTFOUND: GetErrString = "DDERR_NOTFOUND"
    Case DDERR_NOTINITIALIZED: GetErrString = "DDERR_NOTINITIALIZED"
    Case DDERR_NOTLOADED: GetErrString = "DDERR_NOTLOADED"
    Case DDERR_NOTLOCKED: GetErrString = "DDERR_NOTLOCKED"
    Case DDERR_NOTPAGELOCKED: GetErrString = "DDERR_NOTPAGELOCKED"
    Case DDERR_NOTPALETTIZED: GetErrString = "DDERR_NOTPALETTIZED"
    Case DDERR_NOVSYNCHW: GetErrString = "DDERR_NOVSYNCHW"
    Case DDERR_NOZBUFFERHW: GetErrString = "DDERR_NOZBUFFERHW"
    Case DDERR_NOZOVERLAYHW: GetErrString = "DDERR_NOZOVERLAYHW"
    Case DDERR_OUTOFCAPS: GetErrString = "DDERR_OUTOFCAPS"
    Case DDERR_OUTOFMEMORY: GetErrString = "DDERR_OUTOFMEMORY"
    Case DDERR_OUTOFVIDEOMEMORY: GetErrString = "DDERR_OUTOFVIDEOMEMORY"
    Case DDERR_OVERLAPPINGRECTS: GetErrString = "DDERR_OVERLAPPINGRECTS"
    Case DDERR_OVERLAYCANTCLIP: GetErrString = "DDERR_OVERLAYCANTCLIP"
    Case DDERR_OVERLAYCOLORKEYONLYONEACTIVE: GetErrString = "DDERR_OVERLAYCOLORKEYONLYONEACTIVE"
    Case DDERR_OVERLAYNOTVISIBLE: GetErrString = "DDERR_OVERLAYNOTVISIBLE"
    Case DDERR_PALETTEBUSY: GetErrString = "DDERR_PALETTEBUSY"
    Case DDERR_PRIMARYSURFACEALREADYEXISTS: GetErrString = "DDERR_PRIMARYSURFACEALREADYEXISTS"
    Case DDERR_REGIONTOOSMALL: GetErrString = "DDERR_REGIONTOOSMALL"
    Case DDERR_SURFACEALREADYATTACHED: GetErrString = "DDERR_SURFACEALREADYATTACHED"
    Case DDERR_SURFACEALREADYDEPENDENT: GetErrString = "DDERR_SURFACEALREADYDEPENDENT"
    Case DDERR_SURFACEBUSY: GetErrString = "DDERR_SURFACEBUSY"
    Case DDERR_SURFACEISOBSCURED: GetErrString = "DDERR_SURFACEISOBSCURED"
    Case DDERR_SURFACELOST: GetErrString = "DDERR_SURFACELOST"
    Case DDERR_SURFACENOTATTACHED: GetErrString = "DDERR_SURFACENOTATTACHED"
    Case DDERR_TOOBIGHEIGHT: GetErrString = "DDERR_TOOBIGHEIGHT"
    Case DDERR_TOOBIGSIZE: GetErrString = "DDERR_TOOBIGSIZE"
    Case DDERR_TOOBIGWIDTH: GetErrString = "DDERR_TOOBIGWIDTH"
    Case DDERR_UNSUPPORTED: GetErrString = "DDERR_UNSUPPORTED"
    Case DDERR_UNSUPPORTEDFORMAT: GetErrString = "DDERR_UNSUPPORTEDFORMAT"
    Case DDERR_UNSUPPORTEDMASK: GetErrString = "DDERR_UNSUPPORTEDMASK"
    Case DDERR_UNSUPPORTEDMODE: GetErrString = "DDERR_UNSUPPORTEDMODE"
    Case DDERR_VERTICALBLANKINPROGRESS: GetErrString = "DDERR_VERTICALBLANKINPROGRESS"
    Case DDERR_VIDEONOTACTIVE: GetErrString = "DDERR_VIDEONOTACTIVE"
    Case DDERR_WASSTILLDRAWING: GetErrString = "DDERR_WASSTILLDRAWING"
    Case DDERR_WRONGMODE: GetErrString = "DDERR_WRONGMODE"
    Case DDERR_XALIGN: GetErrString = "DDERR_XALIGN"
  End Select
End Function


